<template>
  <v-card align="center" class="pb-3">
    <v-toolbar style="position: relative" color="white" elevation="0">
      <v-spacer />
      <v-toolbar-title class="mt-5">
        <span class="primary--text">
          <v-icon large color="primary" class="mr-2 pb-1">mdi-notebook</v-icon
          ><b>Gerenciamento de entidades filhas</b>
        </span>
      </v-toolbar-title>
      <v-spacer />
      <v-tooltip color="red" bottom>
        <template v-slot:activator="{ on }">
          <v-icon v-on="on" style="position: absolute; right: 15px" color="red" @click="handleClose"
            >mdi-close</v-icon
          >
        </template>
        <span><b>Fechar</b> janela</span>
      </v-tooltip>
    </v-toolbar>
    <span style="font-size: 0.9rem" class="primary--text"
      >Entidade selecionada: <b>{{ entityItem.name }}</b></span
    >
    <v-container grid-list-md text-xs-center fluid fill-height class="mt-2">
      <v-layout style="min-height: 40vh !important" fill-height>
        <!--card 2 - entidades-->
        <v-flex class="px-4" xs12 sm6 md8>
          <v-card>
            <v-row class="entityManageTop" no-gutters>
              <span style="font-size: 0.95rem" class="primary--text"
                ><b>Entidades encontradas</b></span
              >
              <div style="display: flex">
                <v-text-field
                  autofocus
                  class="pa-0 ma-0"
                  style="max-width: 180px"
                  v-model="entitySearch"
                  label="Pesquisar por nome"
                  single-line
                  hide-details
                />
                <v-tooltip color="primary" bottom>
                  <template v-slot:activator="{ on }">
                    <v-btn class="ml-2" fab x-small v-on="on" elevation="0" @click="handleFilter">
                      <v-icon>mdi-magnify</v-icon>
                    </v-btn>
                  </template>
                  <span>Buscar</span>
                </v-tooltip>
              </div>
            </v-row>
            <v-data-table
              :headers="headersEntity"
              :items="entities"
              hide-default-footer
              no-data-text="Não há entidades"
              no-results-text="Nenhuma entidade encontrada com esse nome"
              class="scroll-y elevation-1"
            >
              <template v-slot:[`item.action2`]="{ item }">
                <v-tooltip color="primary" bottom content-class="tooltip2" nudge-top="5px">
                  <template v-slot:activator="{ on }">
                    <v-btn v-on="on" icon @click="confirmMoveColumn('entities', 'children', item)">
                      <v-icon color="primary">mdi-chevron-right</v-icon>
                    </v-btn>
                  </template>
                  <span>Adicionar</span>
                </v-tooltip>
              </template>
            </v-data-table>
            <div class="text-xs-center pt-2">
              <v-pagination
                v-model="pagination.page"
                class="py-2"
                :length="pages"
                @input="readEntitiesManagement"
              />
            </div>
          </v-card>
        </v-flex>

        <!--card 3 - filhas-->
        <v-flex class="px-4">
          <v-card>
            <v-toolbar flat color="white">
              <v-toolbar-title style="font-size: 0.95rem" class="primary--text"
                ><b>Filhas de {{ entityItem.name }} ({{ children.length }})</b></v-toolbar-title
              >
              <v-spacer></v-spacer>
            </v-toolbar>
            <v-data-table
              :headers="headersChildren"
              :items="children"
              no-data-text="Não há filhas"
              class="scroll-y elevation-1"
            >
              <template v-slot:[`item.action1`]="{ item }">
                <v-tooltip color="primary" bottom content-class="tooltip2" nudge-top="5px">
                  <template v-slot:activator="{ on }">
                    <v-btn v-on="on" icon @click="confirmMoveColumn('children', 'entities', item)">
                      <v-icon color="primary">mdi-chevron-left</v-icon>
                    </v-btn>
                  </template>
                  <span>Remover</span>
                </v-tooltip>
              </template>
            </v-data-table>
          </v-card>
        </v-flex>
      </v-layout>
    </v-container>
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="
        moveEntityColumn(itemToMove.queueToRemove, itemToMove.queueToAdd, itemToMove.entity)
      "
    />
  </v-card>
</template>

<script>
import { mapMutations, mapState } from 'vuex'
import User from '../../services/user'
import Management from '../../services/management'

export default {
  name: 'EntitiesManage',
  components: {},
  props: {
    entityItem: {
      type: Object,
      required: true,
    },
  },

  data: () => ({
    alert: {
      status: false,
      message: '',
      icon: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    itemToMove: { queueToRemove: '', queueToAdd: '', entity: {} },
    pagination: {
      totalItems: 0,
      page: 1,
    },

    // card 1 - entidades
    headersEntity: [
      { text: 'Nome', value: 'name', sortable: false },
      { text: 'Ações', value: 'action2', sortable: false },
    ],
    entities: [],
    entitySearch: '',
    active: true,
    visible: true,

    // card 2 - filhas
    headersChildren: [
      { text: 'Ações', value: 'action1', sortable: false },
      { text: 'Nome', value: 'name', sortable: false },
    ],
    children: [],
    successReq: false,
  }),

  computed: {
    ...mapState('user', ['entitiesManage']),
    pages() {
      return Math.ceil(this.pagination.totalItems / 10)
    },
  },
  async created() {
    this.$store.commit('user/UPDATE_LOADING', true)
    await this.readEntityChildren()
    await this.readEntitiesManagement()
    this.$store.commit('user/UPDATE_LOADING', false)
  },
  methods: {
    handleClose() {
      this.$emit('close')
    },

    confirmMoveColumn(queueToRemove, queueToAdd, entity) {
      this.alert.status = true

      if (queueToRemove !== 'children') {
        this.alert.message = `Adicionar entidade <b>${entity.name}</b> como filha de <b>${this.entityItem.name}</b>?`
        this.alert.icon = 'mdi-notebook-plus'
      } else {
        this.alert.message = `Remover entidade <b>${entity.name}</b> das filhas de <b>${this.entityItem.name}</b>?`
        this.alert.icon = 'mdi-delete-circle-outline'
      }

      this.itemToMove.queueToRemove = queueToRemove
      this.itemToMove.queueToAdd = queueToAdd
      this.itemToMove.entity = entity
    },

    async moveEntityColumn(queueToRemove, queueToAdd, entity) {
      this.alert.status = false
      const routedEntity = await this.$getItem('routedEntity'),
        entityId = this.entityItem.id,
        actionsMap = this.$store.state.user.mappedActions,
        actionIdRemove = actionsMap.get('removeEntityFrom').id,
        actionIdAdd = actionsMap.get('addEntityOn').id
      if (queueToRemove === 'children') {
        const updatedEntities = {
          from: this.entityItem.id,
          entitiesId: [entity.id],
        }
        try {
          this.$store.commit('user/UPDATE_LOADING', true)
          let ret = await Management.removeEntityFrom(entityId, actionIdRemove, updatedEntities)
          if (ret.success) {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: 'Entidade filha <b>removida</b> com sucesso!',
              icon: 'mdi-delete-circle-outline',
              color: 'green',
            })
            this.$store.commit('user/UPDATE_LOADING', false)
            this.successReq = true
          }
          if (!ret.success) {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: 'Erro! Não foi possível <b>remover</b> a entidade como filha.',
              icon: 'mdi-close-circle',
              color: 'red',
            })
            this.$store.commit('user/UPDATE_LOADING', false)
          }
        } catch (e) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro! Não foi possível <b>remover</b> a entidade como filha.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } else {
        try {
          const updatedEntitiesAdd = {
            entityId: entity.id,
            to: [this.entityItem.id],
          }
          this.$store.commit('user/UPDATE_LOADING', true)
          let ret = await Management.addEntityOn(entityId, actionIdAdd, updatedEntitiesAdd)
          if (ret.success) {
            this.$store.commit('user/UPDATE_LOADING', false)
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: 'Entidade filha <b>adicionada</b> com sucesso!',
              icon: 'mdi-check-circle',
              color: 'green',
            })
            this.successReq = true
          }
        } catch (e) {
          this.$store.commit('user/UPDATE_LOADING', false)

          if (e.response.data.data.error == 'entityHasParent') {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: 'Erro! Entidade filha <b>já possui uma entidade pai</b>.',
              icon: 'mdi-close-circle',
              color: 'red',
            })
          } else {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: 'Erro! Não foi possível <b>adicionar</b> a entidade como filha.',
              icon: 'mdi-close-circle',
              color: 'red',
            })
          }
        }
      }
      if (this.successReq) {
        this[queueToRemove] = this[queueToRemove].filter((value) => value.id !== entity.id)
        this[queueToAdd].push(entity)
      }
      this.successReq = false
    },

    async readEntitiesManagement() {
      const routedEntity = await this.$getItem('routedEntity'),
        entityId = routedEntity.id,
        actionsMap = this.$store.state.user.mappedActions,
        actionId = actionsMap.get('updateEntity').id,
        search = {
          entityId,
          page: this.pagination.page,
          skip: 10,
        },
        inUseSet = new Set(this.children.map((value) => value.id))
      try {
        const ret = await Management.readEntitiesByPage(entityId, actionId, search)

        let idParentFilter = ''

        let entitiesFiltering = ret.data.entities.filter((value) => {
          if (this.entityItem.id === value.id) {
            idParentFilter = value.parents[0].id
            return false
          }
          return true
        })

        while (entitiesFiltering.some((entity) => entity.id === idParentFilter)) {
          entitiesFiltering = entitiesFiltering.filter((value) => {
            if (idParentFilter === value.id) {
              if (value.parents.length > 0) {
                idParentFilter = value.parents[0].id
              }
              return false
            }
            return true
          })
        }

        this.entities = entitiesFiltering.filter(
          (value) => !inUseSet.has(value.id) && value.id !== this.entityItem.id
        )
        // console.log(this.entities);
        this.pagination.totalItems = ret.data.count
        if (ret.success) {
        }
      } catch (e) {
        console.log(e)
      }
    },

    async readEntityChildren() {
      try {
        let ret = await User.readEntityChild(this.entityItem.id)
        this.children = ret.data
        if (ret.success) {
        }
      } catch (e) {
        console.log('e', e)
      }
    },

    async handleFilter() {
      const routedEntity = await this.$getItem('routedEntity'),
        entityId = routedEntity.id,
        actionsMap = this.$store.state.user.mappedActions,
        actionId = actionsMap.get('updateEntity').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.readEntityByName(entityId, actionId, this.entitySearch)
        this.entities = ret.data
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
        }
      } catch (e) {}
    },
  },
}
</script>

<style>
.entityManageTop {
  height: 55px;
  width: 100%;
  padding-left: 1rem;
  padding-right: 1rem;
  padding-top: 1rem;
  font-size: 1.25rem;
  display: flex;
  align-items: baseline;
  justify-content: space-between;
}
.tooltip2 {
  padding: 2px 10px;
  /* color: #424242; */
}
</style>
